#!/usr/local/bin/perl -w
#
#  Colyleft CryptoManceR 
#  ( http://users.livejournal.com/cryptomancer_/ , 
#    http://cryptomancer.narod.ru/) 
#
#  Either Perl license or GNU GPL at your wish
#
#  Usage: kml2exif point.kml picture.jpg

use Data::Dumper; # for debug only

require XML::Simple;
require Image::ExifTool;

my $xs = new XML::Simple();
my $kml = $xs->XMLin($ARGV[0]);

($lon,$lat,$alt) = split(',',$kml->{'Placemark'}->{'Point'}->{'coordinates'});

$latRef = 'N';
if ($lat < 0) { $latRef = 'S'; $lat = 0-$lat; }

$lonRef = 'E';
if ($lon < 0) { $lonRef = 'W'; $lon = 0-$lon; }

$altRef = '0';
if ($alt < 0) { $altRef = '1'; $alt = 0-$alt; }

my $exifTool = new Image::ExifTool;
					#$info = $exifTool->ImageInfo($ARGV[1]);
					#print Dumper($info);

$exifTool->SetNewValue('GPSLatitude',$lat);
$exifTool->SetNewValue('GPSLongitude',$lon);
$exifTool->SetNewValue('GPSLatitudeRef',$latRef);
$exifTool->SetNewValue('GPSLongitudeRef',$lonRef);
# $exifTool->SetNewValue('GPSAltitudeRef',0); # $altRef); # Broken ?
$exifTool->SetNewValue('GPSAltitude',$alt);

$exifTool->WriteInfo($ARGV[1]);